//!
//! @file usb_task.c,v
//!
//! 쌠 (c) 2006 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧ق͑u/νĂ܂͗̂ǂꂩUSBƂǗ܂B
//!
//! USBƂ͐USB(ݗp\ȓ`ԂɈˑĎsׂ
//! usb_deviceƂ܂usb_host)Iт܂B
//!
//! (conf_usb.ḩٓɔzuꂽ)USB_DEVICE_FEATUREUSB_HOST_FEATURElɏ]
//! ܂Busb_taskUSBu`Ԃ܂USBνē`ԁA܂͓dup
//! ɊւĂ̗x悤Ɍ`Ԑݒ肷邱Ƃł܂B
//!
//! ̕USBSʊ荞ݻٰ݂܂݂܂Bٰ̻݂͔񓯊USBۂ̌
//! oɎgp܂B
//!
//! :
//! - usb_task͌v敔ɑAusb_device_taskusb_host͂łȂA͑S
//!	  ʓIusb_taskĂяo܂B
//! - ̌̕`ԐݒɂĂ̂葽̏ڍׂɊւĂconf_usb.ḩق
//!	  B
//!
//! @version 1.14 at90usb128-demo-touchscreen-1_0_0 $Id: usb_task.c,v 1.14 2006/03/13 10:19:21 rletendu Exp $
//!
//! @todo
//! @bug
//!/

//_____ ݸٰ _______________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "usb_task.h"
#include "usb_drv.h"
#include "usb_descriptors.h"
#include "power_drv.h"
#include "wdt_drv.h"
#include "pll_drv.h"

#if ((USB_HOST_FEATURE == ENABLED))
  #include "usb_host_task.h"
#endif

#if ((USB_DEVICE_FEATURE == ENABLED))
  #include "usb_device_task.h"
#endif

#ifndef USE_USB_PADS_REGULATOR
  #error "USE_USB_PADS_REGULATOR"conf_usb.ḩقENABLE܂DISABLEƂĒ`ׂłB
#endif

//_____ ϸ ___________________________________________________________________

//_____ ` __________________________________________________________________

//!
//! J : U16 g_usb_event
//! usb_connectedUSBSʊ荞ݻٰ݂ŌoꂽUSBۂi[̂Ɏgp
//! ܂B
//! ̒l͈ȉϸۂɂĊǗ܂(usb_task.ḩق)B
//! Usb_send_event(x)
//! Usb_ack_event(x)
//! Usb_clear_all_event()
//! Is_usb_event(x)
//! Is_not_usb_event(x)
volatile U16 g_usb_event=0;

#if (USB_DEVICE_FEATURE == ENABLED)
//!
//! J : (bit) usb_connected
//! usb_connectedVBUSoꂽTRUEɐݒ肳܂B
//! usb_connected̑̏ꍇFALSEɐݒ肳܂B
//! USB_DEVICE_FEATURE==ENABLEDłgp܂B
//!/
extern bit usb_connected;

//!
//! J : (U8) usb_configuration_nb
//! ̒l0ƈقȂ鎞USBuɂĎgpUSB`Ԑݒ萔i[A
//! u`Ԃ(ڑF)ꂽƂӖ܂B
//! USB_DEVICE_FEATURE==ENABLEDłgp܂B
//!/
extern U8 usb_configuration_nb;
#endif

#if (USB_HOST_FEATURE == ENABLED)
//!
//! I : (U8) private_sof_counter
//! νSOF荞ݻٰ݂ɂđ₳܂B
//! ̌vνėvł̎ԒߌoɎgp܂B
//! gp҉pƂɂĕύXĂ͂Ȃ܂B
//!/
volatile U8 private_sof_counter=0;
#endif

#if ((USB_DEVICE_FEATURE == ENABLED)&& (USB_HOST_FEATURE == ENABLED))
//!
//! J : (U8) g_usb_mode
//! USB킪݂̓`Ԃi[邽߂ɓdp(u/νĂ̗)
//! gp܂B
//!/
U8 g_usb_mode=USB_MODE_UNDEFINED;
U8 g_old_usb_mode;
#endif

//_____ 錾 __________________________________________________________________

/**
 * @brief ̊֐USB܂B
 *
 * x铮`(HOST/DEVICE/DUAL_ROLE)ɈˑĊ֐͑ΉUSB`
 * ֐Ăяo܂B
 *
 * @param	Ȃ
 *
 * @return	Ȃ
 */
void usb_task_init (void)
{
  #if (USB_HOST_FEATURE == ENABLED)
	U8 delay;
  #endif

  #if (USE_USB_PADS_REGULATOR==ENABLE)		// ȂUSB߯ޒ͖gpƉ
	Usb_enable_regulator();
  #endif

// ---- d uUSB` ----------------------------------------------
#if ((USB_DEVICE_FEATURE == ENABLED)&& (USB_HOST_FEATURE == ENABLED))
	Usb_enable_uid_pin();
	delay=PORTA;
	g_usb_mode=USB_MODE_UNDEFINED;
	if(Is_usb_id_device())
	{
		g_usb_mode=USB_MODE_DEVICE;
		usb_device_task_init();
	}
	else
	{
		g_usb_mode=USB_MODE_HOST;
		Usb_ack_id_transition();			// Kv!!! ID=0,IDݑJډŎn(ʰ޳n͑u`)
		Usb_enable_id_interrupt();
		Enable_interrupt();
		usb_host_task_init();
	}
	g_old_usb_mode=g_usb_mode;				// `ԕύXô߂Ɍ݂USB`Ԋi[
// ----------------------------------------------------------------------------

// ---- upUSB` ---------------------------------------------------
#elif ((USB_DEVICE_FEATURE == ENABLED)&& (USB_HOST_FEATURE == DISABLE))
	Usb_force_device_mode();
	usb_device_task_init();
// ----------------------------------------------------------------------------

// ---- kνĐpUSB` ------------------------------------------------
#elif ((USB_DEVICE_FEATURE == DISABLE)&& (USB_HOST_FEATURE == ENABLED))
	Usb_force_host_mode();
	usb_host_task_init();
#elif ((USB_DEVICE_FEATURE == DISABLE)&& (USB_HOST_FEATURE == DISABLE))
  #error ŒUSB_DEVICE_FEATURE܂USB_HOST_FEATURE1ׂłB
#endif
// ----------------------------------------------------------------------------
}

/**
 * @brief USBǗ̓(_)
 *
 * x铮`(HOST/DEVICE/DUAL_ROLE)ɈˑĊ֐͑ΉUSBǗ֐
 * Ăяo܂B
 *
 * @param	Ȃ
 *
 * @return	Ȃ
*/
void usb_task (void)
{
// ---- d uUSB` ----------------------------------------------
#if ((USB_DEVICE_FEATURE == ENABLED)&& (USB_HOST_FEATURE == ENABLED))
	if(Is_usb_id_device())
	{ g_usb_mode=USB_MODE_DEVICE;}
	else
	{ g_usb_mode=USB_MODE_HOST;}
	// ׂ!!! ID νďԕύX
	// bǗ:ʰ޳ ؾ!!!
  #if ( ID_PIN_CHANGE_GENERATE_RESET == ENABLE)
	// νIDJڂޯ ؾĂ𐶐
	if((g_old_usb_mode!=g_usb_mode))
	{Wdt_change_16ms(); while(1);}
  #endif
	// ݂USB`ԂɈˑāA݂USB(u܂ν)Jn
	switch(g_usb_mode)
	{
		case USB_MODE_DEVICE:
			usb_device_task();
			break;
		case USB_MODE_HOST:
			usb_host_task();
			break;
		case USB_MODE_UNDEFINED:	// (breakȂ!)
		default:
			break;
	}
// ----------------------------------------------------------------------------

// ---- upUSB` ---------------------------------------------------
#elif ((USB_DEVICE_FEATURE == ENABLED)&& (USB_HOST_FEATURE == DISABLE))
	usb_device_task();
// ----------------------------------------------------------------------------

// ---- kνĐpUSB` ------------------------------------------------
#elif ((USB_DEVICE_FEATURE == DISABLE)&& (USB_HOST_FEATURE == ENABLED))
	usb_host_task();
// ----------------------------------------------------------------------------

//! ---- ُAꂽ`ԂȂ -----------------------------------------
#elif ((USB_DEVICE_FEATURE == DISABLE)&& (USB_HOST_FEATURE == DISABLE))
  #error ŒUSB_DEVICE_FEATURE܂USB_HOST_FEATURE1ׂłB
  #error ȂUSBƂׂ͂̂܂B
#endif
// ----------------------------------------------------------------------------
}

//! @brief USB荞ݻٰ
//!
//! ̊֐USB荞݂NxɌĂ΂܂B
//! ȉUSBۂS܂B
//! - VBUS ON/OFF
//! - ڰт̊Jn
//! - x~(Suspend)
//! - N(Wake-Up)
//! - ĊJ(Resume)
//! - ؾ
//!
//! ȉUSBνĎۂS܂B
//! - uڑ
//! - uؒf
//! - ڰт̊Jn
//! - IDݕω
//! - SOF(܂͒ᑬ(Low-speed)̂܂܈ێ)o
//! - USBoŋN
//!
//! eۂɊւAgp҂͘Ag`邱ƂɂĊJn邱
//! ł܂(ۂŊǉɂconf_usb.ḩق)B
//!
//! : ꂽ荞ݎۂ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
#ifdef AVRGCC
ISR(SIG_USB_GEN)
#else
#pragma vector = USB_GENERAL_vect
__interrupt void usb_general_interrupt()
#endif
{
// ---------- uۊǗ ----------------------------------------------------
#if (USB_DEVICE_FEATURE == ENABLED)
	//- VBUS󋵌o
	if (Is_usb_vbus_transition() && Is_usb_vbus_interrupt_enabled())
	{
		Usb_ack_vbus_transition();
		if (Is_usb_vbus_high())
		{
			usb_connected = TRUE;
			Usb_vbus_on_action();
			Usb_send_event(EVT_USB_POWERED);
			Usb_enable_reset_interrupt();
			usb_start_device();
			Usb_attach();
		}
		else
		{
			Usb_vbus_off_action();
			usb_connected = FALSE;
			Usb_send_event(EVT_USB_UNPOWERED);
		}
	}
	// - uڰъJnM
	if (Is_usb_sof() && Is_sof_interrupt_enabled())
	{
		Usb_ack_sof();
		Usb_sof_action();
	}
	// - ux~(XȂUSB̓oȂ)
	if (Is_usb_suspend() && Is_suspend_interrupt_enabled())
	{
		Usb_ack_suspend();
		Usb_enable_wake_up_interrupt();
		Usb_ack_wake_up();					// ̎یô߂ɋN
		Usb_freeze_clock();
		Usb_send_event(EVT_USB_SUSPEND);
		Usb_suspend_action();
	}
	// - N(USB̓o):ĊJɎgp܂B
	if (Is_usb_wake_up() && Is_swake_up_interrupt_enabled())
	{
		Usb_unfreeze_clock();
		Usb_ack_wake_up();
		Usb_disable_wake_up_interrupt();
		Usb_wake_up_action();
		Usb_send_event(EVT_USB_WAKE_UP);
	}
	// - ĊJ޽o
	if (Is_usb_resume() && Is_resume_interrupt_enabled())
	{
		Usb_disable_wake_up_interrupt();
		Usb_ack_resume();
		Usb_disable_resume_interrupt();
		Usb_resume_action();
		Usb_send_event(EVT_USB_RESUME);
	}
	// - USB޽ ؾČo
	if (Is_usb_reset()&& Is_reset_interrupt_enabled())
	{
		Usb_ack_reset();
		usb_init_device();
		Usb_reset_action();
		Usb_send_event(EVT_USB_RESET);
	}
#endif// DEVICE FEATURE MODEI

// ---------- νĎۊǗ -----------------------------------------------------
#if (USB_HOST_FEATURE == ENABLED)
	// - IDݕωo
	if(Is_usb_id_transition()&&Is_usb_id_interrupt_enabled())
	{
		Usb_ack_id_transition();
		if(Is_usb_id_device())				// u`Ԃ֍s
		{
			Usb_send_event(EVT_USB_DEVICE_FUNCTION);
		}
		else								// νē`Ԃ֍s
		{
			Usb_send_event(EVT_USB_HOST_FUNCTION);
		}
	#if ( ID_PIN_CHANGE_GENERATE_RESET == ENABLE)
		// IDJڂͳޯ ؾĂ𐶐
		Wdt_change_16ms(); while(1);
	#endif
		Usb_id_transition_action();
	}
	// - uؒf܂B
	if(Is_device_disconnection() && Is_host_device_disconnection_interrupt_enabled())
	{
		Host_ack_device_disconnection();
		device_state=DEVICE_UNATTACHED;
		Usb_send_event(EVT_HOST_DISCONNECTION);
		Host_device_disconnection_action();
	}
	// - uڑ
	if(Is_device_connection() && Is_host_device_connection_interrupt_enabled())
	{
		Host_ack_device_connection();
		host_disable_all_pipe();
		Host_device_connection_action();
	}
	// - ν ڰъJno
	if (Is_host_sof() && Is_host_sof_interrupt_enabled())
	{
		Host_ack_sof();
		Usb_send_event(EVT_HOST_SOF);
		private_sof_counter++;
		Host_sof_action();
	}
	// - νċNM
	if (Is_host_hwup() && Is_host_hwup_interrupt_enabled())
	{
		Host_disable_hwup_interrupt();D
		// : HWUPUSBۯ̎ɂ(0)邱Ƃł܂B
		Pll_start_auto();					// USBpPLL̍ŏ̍Ďn
		Wait_pll_ready();					// PLLŒ艻mɂ邽߂̑҂
		Usb_unfreeze_clock();				// USB̪Ÿۯ
		Host_ack_hwup();					// HWUP荞ݗv׸މ(0)
		Usb_send_event(EVT_HOST_HWUP);		// ĳۑo
		Host_hwup_action();					// Ǝ蓖
	}
#endif // HOST FEATURE MODEI
}

extern void suspend_action (void)
{
	Enable_interrupt();
	Enter_power_down_mode();
}

extern void host_suspend_action (void)
{
//	Enter_power_down_mode();
}
